<div class="employees-list mb-5">

  <div class="container">

    <h1 class="mat-h1">Pracownicy</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <ng-container *ngIf="currentUser?.permissions?.canEditEmployees">
          <button mat-raised-button (click)="onCreateEmployeeDialog()">
            <mat-icon>add</mat-icon>
            Dodaj nowego pracownika
          </button>
        </ng-container>
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj pracownika po adresie email" autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="mat-elevation-z8">
        <mat-table [dataSource]="employeesDataSource" matSort>

          <ng-container matColumnDef="email">
            <mat-header-cell *matHeaderCellDef>Email</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.email}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="firstName">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Imię</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.data?.firstName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="lastName">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Nazwisko</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.data?.lastName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="position">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Stanowisko</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.position?.name ? element?.position?.name : '--Nie przydzielono stanowiska--'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="department">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Dział</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.department?.name ? element?.department?.name : '--Nie przydzielono do działu--'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="phoneNumber">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Numer telefonu</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.data?.phoneNumber}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="actions">
            <mat-header-cell *matHeaderCellDef></mat-header-cell>
            <mat-cell *matCellDef="let row">

              <button mat-icon-button color="primary" (click)="onMessageEmployee(row)">
                <mat-icon matTooltip="Wyślij szybką wiadomość">message</mat-icon>
              </button>

              <ng-container *ngIf="currentUser?.permissions?.canEditEmployees">
                <button mat-icon-button (click)="onUpdateEmployeeDialog(row)">
                  <mat-icon matTooltip="Edytuj pracownika">edit</mat-icon>
                </button>
                <button *ngIf="currentUser.id !== row.id" mat-icon-button color="warn"
                        (click)="onAnonymizeEmployee(row)">
                  <mat-icon matTooltip="Anonimizuj pracownika">delete_outline</mat-icon>
                </button>
                <button mat-icon-button color="primary" (click)="onPermissionsEmployeeDialog(row)">
                  <mat-icon matTooltip="Edytuj uprawnienia pracownika">lock_open</mat-icon>
                </button>
                <a mat-icon-button color="accent" [routerLink]="['/company/employees/', row.id]">
                  <mat-icon matTooltip="Zobacz profil pracownika">arrow_forward</mat-icon>
                </a>
              </ng-container>

            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>
          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Brak danych.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':employeesDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(employeesDataSource!=null && employeesDataSource.data.length==0)}"></mat-footer-row>

        </mat-table>
        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>
      </div>
    </mat-card>

  </div>
</div>
